diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tcp/tcp-variants-comparison.cc ns-3.36/examples/tcp/tcp-variants-comparison.cc
--- ns-3.35/examples/tcp/tcp-variants-comparison.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tcp/tcp-variants-comparison.cc	2022-04-30 18:23:57.722732800 -0700
@@ -55,153 +55,179 @@
 
 NS_LOG_COMPONENT_DEFINE ("TcpVariantsComparison");
 
-static bool firstCwnd = true;
-static bool firstSshThr = true;
-static bool firstRtt = true;
-static bool firstRto = true;
-static Ptr<OutputStreamWrapper> cWndStream;
-static Ptr<OutputStreamWrapper> ssThreshStream;
-static Ptr<OutputStreamWrapper> rttStream;
-static Ptr<OutputStreamWrapper> rtoStream;
-static Ptr<OutputStreamWrapper> nextTxStream;
-static Ptr<OutputStreamWrapper> nextRxStream;
-static Ptr<OutputStreamWrapper> inFlightStream;
-static uint32_t cWndValue;
-static uint32_t ssThreshValue;
-
+static std::map<uint32_t, bool> firstCwnd;
+static std::map<uint32_t, bool> firstSshThr;
+static std::map<uint32_t, bool> firstRtt;
+static std::map<uint32_t, bool> firstRto;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> cWndStream;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> ssThreshStream;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> rttStream;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> rtoStream;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> nextTxStream;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> nextRxStream;
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> inFlightStream;
+static std::map<uint32_t, uint32_t> cWndValue;
+static std::map<uint32_t, uint32_t> ssThreshValue;
+
+static uint32_t
+GetNodeIdFromContext (std::string context)
+{
+  std::size_t const n1 = context.find_first_of ("/", 1);
+  std::size_t const n2 = context.find_first_of ("/", n1 + 1);
+  return std::stoul (context.substr (n1 + 1, n2 - n1 - 1));
+}
 
 static void
-CwndTracer (uint32_t oldval, uint32_t newval)
+CwndTracer (std::string context,  uint32_t oldval, uint32_t newval)
 {
-  if (firstCwnd)
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  if (firstCwnd[nodeId])
     {
-      *cWndStream->GetStream () << "0.0 " << oldval << std::endl;
-      firstCwnd = false;
+      *cWndStream[nodeId]->GetStream () << "0.0 " << oldval << std::endl;
+      firstCwnd[nodeId] = false;
     }
-  *cWndStream->GetStream () << Simulator::Now ().GetSeconds () << " " << newval << std::endl;
-  cWndValue = newval;
+  *cWndStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << newval << std::endl;
+  cWndValue[nodeId] = newval;
 
-  if (!firstSshThr)
+  if (!firstSshThr[nodeId])
     {
-      *ssThreshStream->GetStream () << Simulator::Now ().GetSeconds () << " " << ssThreshValue << std::endl;
+      *ssThreshStream[nodeId]->GetStream ()
+          << Simulator::Now ().GetSeconds () << " " << ssThreshValue[nodeId] << std::endl;
     }
 }
 
 static void
-SsThreshTracer (uint32_t oldval, uint32_t newval)
+SsThreshTracer (std::string context, uint32_t oldval, uint32_t newval)
 {
-  if (firstSshThr)
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  if (firstSshThr[nodeId])
     {
-      *ssThreshStream->GetStream () << "0.0 " << oldval << std::endl;
-      firstSshThr = false;
+      *ssThreshStream[nodeId]->GetStream () << "0.0 " << oldval << std::endl;
+      firstSshThr[nodeId] = false;
     }
-  *ssThreshStream->GetStream () << Simulator::Now ().GetSeconds () << " " << newval << std::endl;
-  ssThreshValue = newval;
+  *ssThreshStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << newval << std::endl;
+  ssThreshValue[nodeId] = newval;
 
-  if (!firstCwnd)
+  if (!firstCwnd[nodeId])
     {
-      *cWndStream->GetStream () << Simulator::Now ().GetSeconds () << " " << cWndValue << std::endl;
+      *cWndStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << cWndValue[nodeId] << std::endl;
     }
 }
 
 static void
-RttTracer (Time oldval, Time newval)
+RttTracer (std::string context, Time oldval, Time newval)
 {
-  if (firstRtt)
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  if (firstRtt[nodeId])
     {
-      *rttStream->GetStream () << "0.0 " << oldval.GetSeconds () << std::endl;
-      firstRtt = false;
+      *rttStream[nodeId]->GetStream () << "0.0 " << oldval.GetSeconds () << std::endl;
+      firstRtt[nodeId] = false;
     }
-  *rttStream->GetStream () << Simulator::Now ().GetSeconds () << " " << newval.GetSeconds () << std::endl;
+  *rttStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << newval.GetSeconds () << std::endl;
 }
 
 static void
-RtoTracer (Time oldval, Time newval)
+RtoTracer (std::string context, Time oldval, Time newval)
 {
-  if (firstRto)
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  if (firstRto[nodeId])
     {
-      *rtoStream->GetStream () << "0.0 " << oldval.GetSeconds () << std::endl;
-      firstRto = false;
+      *rtoStream[nodeId]->GetStream () << "0.0 " << oldval.GetSeconds () << std::endl;
+      firstRto[nodeId] = false;
     }
-  *rtoStream->GetStream () << Simulator::Now ().GetSeconds () << " " << newval.GetSeconds () << std::endl;
+  *rtoStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << newval.GetSeconds () << std::endl;
 }
 
 static void
-NextTxTracer (SequenceNumber32 old, SequenceNumber32 nextTx)
+NextTxTracer (std::string context, [[maybe_unused]] SequenceNumber32 old, SequenceNumber32 nextTx)
 {
-  NS_UNUSED (old);
-  *nextTxStream->GetStream () << Simulator::Now ().GetSeconds () << " " << nextTx << std::endl;
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  *nextTxStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << nextTx << std::endl;
 }
 
 static void
-InFlightTracer (uint32_t old, uint32_t inFlight)
+InFlightTracer (std::string context, [[maybe_unused]] uint32_t old, uint32_t inFlight)
 {
-  NS_UNUSED (old);
-  *inFlightStream->GetStream () << Simulator::Now ().GetSeconds () << " " << inFlight << std::endl;
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  *inFlightStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << inFlight << std::endl;
 }
 
 static void
-NextRxTracer (SequenceNumber32 old, SequenceNumber32 nextRx)
+NextRxTracer (std::string context, [[maybe_unused]] SequenceNumber32 old, SequenceNumber32 nextRx)
 {
-  NS_UNUSED (old);
-  *nextRxStream->GetStream () << Simulator::Now ().GetSeconds () << " " << nextRx << std::endl;
+  uint32_t nodeId = GetNodeIdFromContext (context);
+
+  *nextRxStream[nodeId]->GetStream () << Simulator::Now ().GetSeconds () << " " << nextRx << std::endl;
 }
 
 static void
-TraceCwnd (std::string cwnd_tr_file_name)
+TraceCwnd (std::string cwnd_tr_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  cWndStream = ascii.CreateFileStream (cwnd_tr_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/1/$ns3::TcpL4Protocol/SocketList/0/CongestionWindow", MakeCallback (&CwndTracer));
+  cWndStream[nodeId] = ascii.CreateFileStream (cwnd_tr_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/0/CongestionWindow",
+                   MakeCallback (&CwndTracer));
 }
 
 static void
-TraceSsThresh (std::string ssthresh_tr_file_name)
+TraceSsThresh (std::string ssthresh_tr_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  ssThreshStream = ascii.CreateFileStream (ssthresh_tr_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/1/$ns3::TcpL4Protocol/SocketList/0/SlowStartThreshold", MakeCallback (&SsThreshTracer));
+  ssThreshStream[nodeId] = ascii.CreateFileStream (ssthresh_tr_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/0/SlowStartThreshold",
+                   MakeCallback (&SsThreshTracer));
 }
 
 static void
-TraceRtt (std::string rtt_tr_file_name)
+TraceRtt (std::string rtt_tr_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  rttStream = ascii.CreateFileStream (rtt_tr_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/1/$ns3::TcpL4Protocol/SocketList/0/RTT", MakeCallback (&RttTracer));
+  rttStream[nodeId] = ascii.CreateFileStream (rtt_tr_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/0/RTT",
+                   MakeCallback (&RttTracer));
 }
 
 static void
-TraceRto (std::string rto_tr_file_name)
+TraceRto (std::string rto_tr_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  rtoStream = ascii.CreateFileStream (rto_tr_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/1/$ns3::TcpL4Protocol/SocketList/0/RTO", MakeCallback (&RtoTracer));
+  rtoStream[nodeId] = ascii.CreateFileStream (rto_tr_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/0/RTO",
+                   MakeCallback (&RtoTracer));
 }
 
 static void
-TraceNextTx (std::string &next_tx_seq_file_name)
+TraceNextTx (std::string &next_tx_seq_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  nextTxStream = ascii.CreateFileStream (next_tx_seq_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/1/$ns3::TcpL4Protocol/SocketList/0/NextTxSequence", MakeCallback (&NextTxTracer));
+  nextTxStream[nodeId] = ascii.CreateFileStream (next_tx_seq_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/0/NextTxSequence",
+                   MakeCallback (&NextTxTracer));
 }
 
 static void
-TraceInFlight (std::string &in_flight_file_name)
+TraceInFlight (std::string &in_flight_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  inFlightStream = ascii.CreateFileStream (in_flight_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/1/$ns3::TcpL4Protocol/SocketList/0/BytesInFlight", MakeCallback (&InFlightTracer));
+  inFlightStream[nodeId] = ascii.CreateFileStream (in_flight_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/0/BytesInFlight",
+                   MakeCallback (&InFlightTracer));
 }
 
-
 static void
-TraceNextRx (std::string &next_rx_seq_file_name)
+TraceNextRx (std::string &next_rx_seq_file_name, uint32_t nodeId)
 {
   AsciiTraceHelper ascii;
-  nextRxStream = ascii.CreateFileStream (next_rx_seq_file_name.c_str ());
-  Config::ConnectWithoutContext ("/NodeList/2/$ns3::TcpL4Protocol/SocketList/1/RxBuffer/NextRxSequence", MakeCallback (&NextRxTracer));
+  nextRxStream[nodeId] = ascii.CreateFileStream (next_rx_seq_file_name.c_str ());
+  Config::Connect ("/NodeList/" + std::to_string (nodeId) +
+                       "/$ns3::TcpL4Protocol/SocketList/1/RxBuffer/NextRxSequence",
+                   MakeCallback (&NextRxTracer));
 }
 
 int main (int argc, char *argv[])
@@ -416,13 +442,34 @@
                                             std::ios::out);
       stack.EnableAsciiIpv4All (ascii_wrap);
 
-      Simulator::Schedule (Seconds (0.00001), &TraceCwnd, prefix_file_name + "-cwnd.data");
-      Simulator::Schedule (Seconds (0.00001), &TraceSsThresh, prefix_file_name + "-ssth.data");
-      Simulator::Schedule (Seconds (0.00001), &TraceRtt, prefix_file_name + "-rtt.data");
-      Simulator::Schedule (Seconds (0.00001), &TraceRto, prefix_file_name + "-rto.data");
-      Simulator::Schedule (Seconds (0.00001), &TraceNextTx, prefix_file_name + "-next-tx.data");
-      Simulator::Schedule (Seconds (0.00001), &TraceInFlight, prefix_file_name + "-inflight.data");
-      Simulator::Schedule (Seconds (0.1), &TraceNextRx, prefix_file_name + "-next-rx.data");
+      for (uint16_t index = 0; index < num_flows; index++)
+        {
+          std::string flowString ("");
+          if (num_flows>1)
+            {
+              flowString = "-flow" + std::to_string (index);
+            }
+
+          firstCwnd[index+1] = true;
+          firstSshThr[index+1] = true;
+          firstRtt[index+1] = true;
+          firstRto[index+1] = true;
+
+          Simulator::Schedule (Seconds (start_time * index + 0.00001), &TraceCwnd,
+                               prefix_file_name + flowString + "-cwnd.data", index+1);
+          Simulator::Schedule (Seconds (start_time * index + 0.00001), &TraceSsThresh,
+                               prefix_file_name + flowString + "-ssth.data", index+1);
+          Simulator::Schedule (Seconds (start_time * index + 0.00001), &TraceRtt,
+                               prefix_file_name + flowString + "-rtt.data", index+1);
+          Simulator::Schedule (Seconds (start_time * index + 0.00001), &TraceRto,
+                               prefix_file_name + flowString + "-rto.data", index+1);
+          Simulator::Schedule (Seconds (start_time * index + 0.00001), &TraceNextTx,
+                               prefix_file_name + flowString + "-next-tx.data", index+1);
+          Simulator::Schedule (Seconds (start_time * index + 0.00001), &TraceInFlight,
+                               prefix_file_name + flowString + "-inflight.data", index+1);
+          Simulator::Schedule (Seconds (start_time * index + 0.1), &TraceNextRx,
+                               prefix_file_name + flowString + "-next-rx.data", num_flows+index+1);
+        }
     }
 
   if (pcap)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/traffic-control/CMakeLists.txt ns-3.36/examples/traffic-control/CMakeLists.txt
--- ns-3.35/examples/traffic-control/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/traffic-control/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,64 @@
+build_example(
+  NAME traffic-control
+  SOURCE_FILES traffic-control.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libapplications}
+    ${libtraffic-control}
+    ${libflow-monitor}
+)
+
+build_example(
+  NAME queue-discs-benchmark
+  SOURCE_FILES queue-discs-benchmark.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libapplications}
+    ${libinternet-apps}
+    ${libtraffic-control}
+    ${libflow-monitor}
+)
+
+build_example(
+  NAME red-vs-fengadaptive
+  SOURCE_FILES red-vs-fengadaptive.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libpoint-to-point-layout}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_example(
+  NAME red-vs-nlred
+  SOURCE_FILES red-vs-nlred.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libpoint-to-point-layout}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_example(
+  NAME tbf-example
+  SOURCE_FILES tbf-example.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_example(
+  NAME cobalt-vs-codel
+  SOURCE_FILES cobalt-vs-codel.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libapplications}
+    ${libtraffic-control}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/CMakeLists.txt ns-3.36/examples/tutorial/CMakeLists.txt
--- ns-3.35/examples/tutorial/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/tutorial/CMakeLists.txt	2022-04-30 18:23:57.722732800 -0700
@@ -0,0 +1,78 @@
+build_example(
+  NAME hello-simulator
+  SOURCE_FILES hello-simulator.cc
+  LIBRARIES_TO_LINK ${libcore}
+)
+
+build_example(
+  NAME first
+  SOURCE_FILES first.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME second
+  SOURCE_FILES second.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME third
+  SOURCE_FILES third.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libpoint-to-point}
+    ${libcsma}
+    ${libwifi}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME fourth
+  SOURCE_FILES fourth.cc
+  LIBRARIES_TO_LINK ${libcore}
+)
+
+build_example(
+  NAME fifth
+  SOURCE_FILES fifth.cc
+               tutorial-app.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME sixth
+  SOURCE_FILES sixth.cc
+               tutorial-app.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME seventh
+  SOURCE_FILES seventh.cc
+               tutorial-app.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libstats}
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/fifth.cc ns-3.36/examples/tutorial/fifth.cc
--- ns-3.35/examples/tutorial/fifth.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tutorial/fifth.cc	2022-04-30 18:23:57.722732800 -0700
@@ -18,8 +18,9 @@
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
 #include "ns3/internet-module.h"
-#include "ns3/point-to-point-module.h"
 #include "ns3/applications-module.h"
+#include "ns3/point-to-point-module.h"
+#include "tutorial-app.h"
 
 using namespace ns3;
 
@@ -59,106 +60,7 @@
 // install in the source node.
 // ===========================================================================
 //
-class MyApp : public Application 
-{
-public:
-
-  MyApp ();
-  virtual ~MyApp();
-
-  void Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate);
-
-private:
-  virtual void StartApplication (void);
-  virtual void StopApplication (void);
-
-  void ScheduleTx (void);
-  void SendPacket (void);
-
-  Ptr<Socket>     m_socket;
-  Address         m_peer;
-  uint32_t        m_packetSize;
-  uint32_t        m_nPackets;
-  DataRate        m_dataRate;
-  EventId         m_sendEvent;
-  bool            m_running;
-  uint32_t        m_packetsSent;
-};
-
-MyApp::MyApp ()
-  : m_socket (0), 
-    m_peer (), 
-    m_packetSize (0), 
-    m_nPackets (0), 
-    m_dataRate (0), 
-    m_sendEvent (), 
-    m_running (false), 
-    m_packetsSent (0)
-{
-}
-
-MyApp::~MyApp()
-{
-  m_socket = 0;
-}
-
-void
-MyApp::Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate)
-{
-  m_socket = socket;
-  m_peer = address;
-  m_packetSize = packetSize;
-  m_nPackets = nPackets;
-  m_dataRate = dataRate;
-}
 
-void
-MyApp::StartApplication (void)
-{
-  m_running = true;
-  m_packetsSent = 0;
-  m_socket->Bind ();
-  m_socket->Connect (m_peer);
-  SendPacket ();
-}
-
-void 
-MyApp::StopApplication (void)
-{
-  m_running = false;
-
-  if (m_sendEvent.IsRunning ())
-    {
-      Simulator::Cancel (m_sendEvent);
-    }
-
-  if (m_socket)
-    {
-      m_socket->Close ();
-    }
-}
-
-void 
-MyApp::SendPacket (void)
-{
-  Ptr<Packet> packet = Create<Packet> (m_packetSize);
-  m_socket->Send (packet);
-
-  if (++m_packetsSent < m_nPackets)
-    {
-      ScheduleTx ();
-    }
-}
-
-void 
-MyApp::ScheduleTx (void)
-{
-  if (m_running)
-    {
-      Time tNext (Seconds (m_packetSize * 8 / static_cast<double> (m_dataRate.GetBitRate ())));
-      m_sendEvent = Simulator::Schedule (tNext, &MyApp::SendPacket, this);
-    }
-}
 
 static void
 CwndChange (uint32_t oldCwnd, uint32_t newCwnd)
@@ -177,6 +79,16 @@
 {
   CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
+
+  // In the following three lines, TCP NewReno is used as the congestion
+  // control algorithm, the initial congestion window of a TCP connection is
+  // set to 1 packet, and the classic fast recovery algorithm is used. Note
+  // that this configuration is used only to demonstrate how TCP parameters
+  // can be configured in ns-3. Otherwise, it is recommended to use the default
+  // settings of TCP in ns-3.
+  Config::SetDefault ("ns3::TcpL4Protocol::SocketType", StringValue ("ns3::TcpNewReno"));
+  Config::SetDefault ("ns3::TcpSocket::InitialCwnd", UintegerValue (1));
+  Config::SetDefault ("ns3::TcpL4Protocol::RecoveryType", TypeIdValue (TypeId::LookupByName ("ns3::TcpClassicRecovery")));
   
   NodeContainer nodes;
   nodes.Create (2);
@@ -209,7 +121,7 @@
   Ptr<Socket> ns3TcpSocket = Socket::CreateSocket (nodes.Get (0), TcpSocketFactory::GetTypeId ());
   ns3TcpSocket->TraceConnectWithoutContext ("CongestionWindow", MakeCallback (&CwndChange));
 
-  Ptr<MyApp> app = CreateObject<MyApp> ();
+  Ptr<TutorialApp> app = CreateObject<TutorialApp> ();
   app->Setup (ns3TcpSocket, sinkAddress, 1040, 1000, DataRate ("1Mbps"));
   nodes.Get (0)->AddApplication (app);
   app->SetStartTime (Seconds (1.));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/fourth.cc ns-3.36/examples/tutorial/fourth.cc
--- ns-3.35/examples/tutorial/fourth.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tutorial/fourth.cc	2022-04-30 18:23:57.726733000 -0700
@@ -18,11 +18,15 @@
 #include "ns3/uinteger.h"
 #include "ns3/traced-value.h"
 #include "ns3/trace-source-accessor.h"
+#include "ns3/simulator.h"
 
 #include <iostream>
 
 using namespace ns3;
 
+/**
+ * Tutorial 4 - a simple Object to show how to hook a trace.
+ */
 class MyObject : public Object
 {
 public:
@@ -45,7 +49,7 @@
   }
 
   MyObject () {}
-  TracedValue<int32_t> m_myInt;
+  TracedValue<int32_t> m_myInt; //!< The traced value.
 };
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/seventh.cc ns-3.36/examples/tutorial/seventh.cc
--- ns-3.35/examples/tutorial/seventh.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tutorial/seventh.cc	2022-04-30 18:23:57.726733000 -0700
@@ -18,9 +18,10 @@
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
 #include "ns3/internet-module.h"
-#include "ns3/point-to-point-module.h"
 #include "ns3/applications-module.h"
+#include "ns3/point-to-point-module.h"
 #include "ns3/stats-module.h"
+#include "tutorial-app.h"
 
 using namespace ns3;
 
@@ -63,128 +64,7 @@
 // in src/stats/docs/seventh-packet-byte-count.png
 // ===========================================================================
 //
-class MyApp : public Application
-{
-public:
-  MyApp ();
-  virtual ~MyApp ();
-
-  /**
-   * Register this type.
-   * \return The TypeId.
-   */
-  static TypeId GetTypeId (void);
-  void Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate);
-
-private:
-  virtual void StartApplication (void);
-  virtual void StopApplication (void);
-
-  void ScheduleTx (void);
-  void SendPacket (void);
-
-  Ptr<Socket>     m_socket;
-  Address         m_peer;
-  uint32_t        m_packetSize;
-  uint32_t        m_nPackets;
-  DataRate        m_dataRate;
-  EventId         m_sendEvent;
-  bool            m_running;
-  uint32_t        m_packetsSent;
-};
-
-MyApp::MyApp ()
-  : m_socket (0),
-    m_peer (),
-    m_packetSize (0),
-    m_nPackets (0),
-    m_dataRate (0),
-    m_sendEvent (),
-    m_running (false),
-    m_packetsSent (0)
-{
-}
-
-MyApp::~MyApp ()
-{
-  m_socket = 0;
-}
-
-/* static */
-TypeId MyApp::GetTypeId (void)
-{
-  static TypeId tid = TypeId ("MyApp")
-    .SetParent<Application> ()
-    .SetGroupName ("Tutorial")
-    .AddConstructor<MyApp> ()
-    ;
-  return tid;
-}
 
-void
-MyApp::Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate)
-{
-  m_socket = socket;
-  m_peer = address;
-  m_packetSize = packetSize;
-  m_nPackets = nPackets;
-  m_dataRate = dataRate;
-}
-
-void
-MyApp::StartApplication (void)
-{
-  m_running = true;
-  m_packetsSent = 0;
-  if (InetSocketAddress::IsMatchingType (m_peer))
-    {
-      m_socket->Bind ();
-    }
-  else
-    {
-      m_socket->Bind6 ();
-    }
-  m_socket->Connect (m_peer);
-  SendPacket ();
-}
-
-void
-MyApp::StopApplication (void)
-{
-  m_running = false;
-
-  if (m_sendEvent.IsRunning ())
-    {
-      Simulator::Cancel (m_sendEvent);
-    }
-
-  if (m_socket)
-    {
-      m_socket->Close ();
-    }
-}
-
-void
-MyApp::SendPacket (void)
-{
-  Ptr<Packet> packet = Create<Packet> (m_packetSize);
-  m_socket->Send (packet);
-
-  if (++m_packetsSent < m_nPackets)
-    {
-      ScheduleTx ();
-    }
-}
-
-void
-MyApp::ScheduleTx (void)
-{
-  if (m_running)
-    {
-      Time tNext (Seconds (m_packetSize * 8 / static_cast<double> (m_dataRate.GetBitRate ())));
-      m_sendEvent = Simulator::Schedule (tNext, &MyApp::SendPacket, this);
-    }
-}
 
 static void
 CwndChange (Ptr<OutputStreamWrapper> stream, uint32_t oldCwnd, uint32_t newCwnd)
@@ -259,7 +139,7 @@
 
   Ptr<Socket> ns3TcpSocket = Socket::CreateSocket (nodes.Get (0), TcpSocketFactory::GetTypeId ());
 
-  Ptr<MyApp> app = CreateObject<MyApp> ();
+  Ptr<TutorialApp> app = CreateObject<TutorialApp> ();
   app->Setup (ns3TcpSocket, sinkAddress, 1040, 1000, DataRate ("1Mbps"));
   nodes.Get (0)->AddApplication (app);
   app->SetStartTime (Seconds (1.));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/sixth.cc ns-3.36/examples/tutorial/sixth.cc
--- ns-3.35/examples/tutorial/sixth.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tutorial/sixth.cc	2022-04-30 18:23:57.726733000 -0700
@@ -18,8 +18,9 @@
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
 #include "ns3/internet-module.h"
-#include "ns3/point-to-point-module.h"
 #include "ns3/applications-module.h"
+#include "ns3/point-to-point-module.h"
+#include "tutorial-app.h"
 
 using namespace ns3;
 
@@ -59,121 +60,7 @@
 // install in the source node.
 // ===========================================================================
 //
-class MyApp : public Application
-{
-public:
-  MyApp ();
-  virtual ~MyApp ();
-
-  /**
-   * Register this type.
-   * \return The TypeId.
-   */
-  static TypeId GetTypeId (void);
-  void Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate);
-
-private:
-  virtual void StartApplication (void);
-  virtual void StopApplication (void);
-
-  void ScheduleTx (void);
-  void SendPacket (void);
-
-  Ptr<Socket>     m_socket;
-  Address         m_peer;
-  uint32_t        m_packetSize;
-  uint32_t        m_nPackets;
-  DataRate        m_dataRate;
-  EventId         m_sendEvent;
-  bool            m_running;
-  uint32_t        m_packetsSent;
-};
-
-MyApp::MyApp ()
-  : m_socket (0),
-    m_peer (),
-    m_packetSize (0),
-    m_nPackets (0),
-    m_dataRate (0),
-    m_sendEvent (),
-    m_running (false),
-    m_packetsSent (0)
-{
-}
-
-MyApp::~MyApp ()
-{
-  m_socket = 0;
-}
-
-/* static */
-TypeId MyApp::GetTypeId (void)
-{
-  static TypeId tid = TypeId ("MyApp")
-    .SetParent<Application> ()
-    .SetGroupName ("Tutorial")
-    .AddConstructor<MyApp> ()
-    ;
-  return tid;
-}
-
-void
-MyApp::Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate)
-{
-  m_socket = socket;
-  m_peer = address;
-  m_packetSize = packetSize;
-  m_nPackets = nPackets;
-  m_dataRate = dataRate;
-}
 
-void
-MyApp::StartApplication (void)
-{
-  m_running = true;
-  m_packetsSent = 0;
-  m_socket->Bind ();
-  m_socket->Connect (m_peer);
-  SendPacket ();
-}
-
-void
-MyApp::StopApplication (void)
-{
-  m_running = false;
-
-  if (m_sendEvent.IsRunning ())
-    {
-      Simulator::Cancel (m_sendEvent);
-    }
-
-  if (m_socket)
-    {
-      m_socket->Close ();
-    }
-}
-
-void
-MyApp::SendPacket (void)
-{
-  Ptr<Packet> packet = Create<Packet> (m_packetSize);
-  m_socket->Send (packet);
-
-  if (++m_packetsSent < m_nPackets)
-    {
-      ScheduleTx ();
-    }
-}
-
-void
-MyApp::ScheduleTx (void)
-{
-  if (m_running)
-    {
-      Time tNext (Seconds (m_packetSize * 8 / static_cast<double> (m_dataRate.GetBitRate ())));
-      m_sendEvent = Simulator::Schedule (tNext, &MyApp::SendPacket, this);
-    }
-}
 
 static void
 CwndChange (Ptr<OutputStreamWrapper> stream, uint32_t oldCwnd, uint32_t newCwnd)
@@ -225,7 +112,7 @@
 
   Ptr<Socket> ns3TcpSocket = Socket::CreateSocket (nodes.Get (0), TcpSocketFactory::GetTypeId ());
 
-  Ptr<MyApp> app = CreateObject<MyApp> ();
+  Ptr<TutorialApp> app = CreateObject<TutorialApp> ();
   app->Setup (ns3TcpSocket, sinkAddress, 1040, 1000, DataRate ("1Mbps"));
   nodes.Get (0)->AddApplication (app);
   app->SetStartTime (Seconds (1.));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/third.cc ns-3.36/examples/tutorial/third.cc
--- ns-3.35/examples/tutorial/third.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tutorial/third.cc	2022-04-30 18:23:57.726733000 -0700
@@ -99,22 +99,20 @@
   YansWifiPhyHelper phy;
   phy.SetChannel (channel.Create ());
 
-  WifiHelper wifi;
-  wifi.SetRemoteStationManager ("ns3::AarfWifiManager");
-
   WifiMacHelper mac;
   Ssid ssid = Ssid ("ns-3-ssid");
+
+  WifiHelper wifi;
+
+  NetDeviceContainer staDevices;
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid),
                "ActiveProbing", BooleanValue (false));
-
-  NetDeviceContainer staDevices;
   staDevices = wifi.Install (phy, mac, wifiStaNodes);
 
+  NetDeviceContainer apDevices;
   mac.SetType ("ns3::ApWifiMac",
                "Ssid", SsidValue (ssid));
-
-  NetDeviceContainer apDevices;
   apDevices = wifi.Install (phy, mac, wifiApNode);
 
   MobilityHelper mobility;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/third.py ns-3.36/examples/tutorial/third.py
--- ns-3.35/examples/tutorial/third.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/tutorial/third.py	2022-04-30 18:23:57.726733000 -0700
@@ -93,12 +93,11 @@
 phy = ns.wifi.YansWifiPhyHelper()
 phy.SetChannel(channel.Create())
 
-wifi = ns.wifi.WifiHelper()
-wifi.SetRemoteStationManager("ns3::AarfWifiManager")
-
 mac = ns.wifi.WifiMacHelper()
 ssid = ns.wifi.Ssid ("ns-3-ssid")
 
+wifi = ns.wifi.WifiHelper()
+
 mac.SetType ("ns3::StaWifiMac", "Ssid", ns.wifi.SsidValue(ssid), "ActiveProbing", ns.core.BooleanValue(False))
 staDevices = wifi.Install(phy, mac, wifiStaNodes)
 
